leetcode 2054(排序 + 单调栈,通用做法是 DP)

2054: 两个最好的不重叠活动

题意:在结束时间小于 startTime 的活动中,选择价值最大的活动。

为了方便查找,先把 events 按照++结束时间++从小到大排序。

排序后,对比如下两个活动:

  • 活动一:结束于 3 时刻,价值 999。
  • 活动二:结束于 6 时刻,价值 9。

活动二的结束时间又晚,价值又小,全方面不如活动一,是垃圾数据,直接忽略。

换句话说,在遍历 events 的过程中(注意 events 已按照结束时间排序),只在遇到更大价值的活动时,才记录该活动。把这些活动记录到一个栈(列表)中,那么从栈底到栈顶,结束时间是递增的,价值也是递增的,非常适合++二分查找++。

枚举第二个活动,在单调栈中二分查找结束时间严格小于 startTime 的最后一个活动,即为价值最大的第一个活动。如果没找到,那么只能选一个活动。

为了简化判断逻辑,可以在栈底加一个结束时间为 0,价值也为 0 的哨兵。

复制代码
ranges::sort(events,{},[](auto& e){return e[1];});
复制代码
vector<pair<int,int>> st={{0,0}}; //栈底哨兵

auto it=--ranges::lower_bound(st,start_time,{},&pair<int,int>::first);
ans=max(ans,it->second+value);

单调栈递增,如果找不到,因为有"栈底哨兵",因此找不到满足条件的活动时,it={0,0},it->second=0,不会越界。

复制代码
class Solution {
public:
    int maxTwoEvents(vector<vector<int>>& events) {
        //按照结束时间升序排序
        ranges::sort(events,{},[](auto& e){return e[1];});
        //从栈底到栈顶,结束时间递增,价值递增
        vector<pair<int,int>> st={{0,0}}; //栈底哨兵
        int ans=0;
        for(auto& e:events){
            int start_time=e[0],value=e[2];
            //二分查找最后一个结束时间 < start_time 的活动
            auto it=--ranges::lower_bound(st,start_time,{},&pair<int,int>::first);
            ans=max(ans,it->second+value);
            if(value>st.back().second) st.emplace_back(e[1],value);
        }

        return ans;
    }
};
相关推荐
邵奈一18 分钟前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS10019 分钟前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao33 分钟前
算法56,重排链表
数据结构·算法·链表
qq_452396231 小时前
第四篇:《索引原理与实战:B-tree、Hash、GIN、GiST、BRIN》
算法·哈希算法·gin
西索斯coding2 小时前
Qwen3-Max 与 Qwen-Plus:60 个真实修复任务评测方案
大数据·网络·算法·ai
INGNIGHT2 小时前
440 · 背包问题(三)(无限次数)
算法·leetcode·动态规划
suhan2 小时前
【数据结构】七、查找:1.查找的概念、线性结构查找(顺序、折半(二分)、插值、稠密、分块、倒排)
数据结构·算法·排序算法
极客 - L U2 小时前
卡尔曼滤波从零到精通
c语言·数据结构·单片机·嵌入式硬件·mcu
killerbasd3 小时前
总结 10.26
算法